function out = AdaptC
out{1} = @init;
out{2} = @fun_eval;
out{3} = @jacobian;
out{4} = @jacobianp;
out{5} = @hessians;
out{6} = @hessiansp;
out{7} = @der3;
out{8} = @der4;
out{9} = @der5;

% --------------------------------------------------------------------------
function dydt = fun_eval(t,kmrgd,BB,CC,KK)
dydt=[kmrgd(2);;
BB*kmrgd(1)+KK+kmrgd(3)*kmrgd(2);;
kmrgd(3)- KK*kmrgd(2)/(CC+kmrgd(2)^2)*(BB*kmrgd(1)+KK+kmrgd(3)*kmrgd(2)-1);;];

% --------------------------------------------------------------------------
function [tspan,y0,options] = init
handles = feval(AdaptC);
y0=[0,0,0];
options = odeset('Jacobian',handles(3),'JacobianP',handles(4),'Hessians',handles(5),'HessiansP',handles(6));
tspan = [0 10];

% --------------------------------------------------------------------------
function jac = jacobian(t,kmrgd,BB,CC,KK)
jac=[[0,1,0];[BB,kmrgd(3),kmrgd(2)];[-(BB*KK*kmrgd(2))/(kmrgd(2)^2 + CC),(2*KK*kmrgd(2)^2*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^2 - (KK*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC) - (KK*kmrgd(2)*kmrgd(3))/(kmrgd(2)^2 + CC),1 - (KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)]];
% --------------------------------------------------------------------------
function jacp = jacobianp(t,kmrgd,BB,CC,KK)
jacp=[[0,0,0];[kmrgd(1),0,1];[-(KK*kmrgd(1)*kmrgd(2))/(kmrgd(2)^2 + CC),(KK*kmrgd(2)*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^2,- (kmrgd(2)*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC) - (KK*kmrgd(2))/(kmrgd(2)^2 + CC)]];
% --------------------------------------------------------------------------
function hess = hessians(t,kmrgd,BB,CC,KK)
hess1=[[0,0,0];[0,0,0];[0,(2*BB*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^2 - (BB*KK)/(kmrgd(2)^2 + CC),0]];
hess2=[[0,0,0];[0,0,1];[(2*BB*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^2 - (BB*KK)/(kmrgd(2)^2 + CC),(6*KK*kmrgd(2)*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^2 - (2*KK*kmrgd(3))/(kmrgd(2)^2 + CC) - (8*KK*kmrgd(2)^3*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^3 + (4*KK*kmrgd(2)^2*kmrgd(3))/(kmrgd(2)^2 + CC)^2,(2*KK*kmrgd(2)^3)/(kmrgd(2)^2 + CC)^2 - (2*KK*kmrgd(2))/(kmrgd(2)^2 + CC)]];
hess3=[[0,0,0];[0,1,0];[0,(2*KK*kmrgd(2)^3)/(kmrgd(2)^2 + CC)^2 - (2*KK*kmrgd(2))/(kmrgd(2)^2 + CC),0]];
hess(:,:,1) =hess1;
hess(:,:,2) =hess2;
hess(:,:,3) =hess3;
% --------------------------------------------------------------------------
function hessp = hessiansp(t,kmrgd,BB,CC,KK)
hessp1=[[0,0,0];[1,0,0];[-(KK*kmrgd(2))/(kmrgd(2)^2 + CC),(2*KK*kmrgd(1)*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^2 - (KK*kmrgd(1))/(kmrgd(2)^2 + CC),0]];
hessp2=[[0,0,0];[0,0,0];[(BB*KK*kmrgd(2))/(kmrgd(2)^2 + CC)^2,(KK*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^2 - (4*KK*kmrgd(2)^2*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^3 + (KK*kmrgd(2)*kmrgd(3))/(kmrgd(2)^2 + CC)^2,(KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^2]];
hessp3=[[0,0,0];[0,0,0];[-(BB*kmrgd(2))/(kmrgd(2)^2 + CC),(2*kmrgd(2)^2*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^2 - KK/(kmrgd(2)^2 + CC) - (KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1)/(kmrgd(2)^2 + CC) - (kmrgd(2)*kmrgd(3))/(kmrgd(2)^2 + CC) + (2*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^2,-kmrgd(2)^2/(kmrgd(2)^2 + CC)]];
hessp(:,:,1) =hessp1;
hessp(:,:,2) =hessp2;
hessp(:,:,3) =hessp3;
%---------------------------------------------------------------------------
function tens3  = der3(t,kmrgd,BB,CC,KK)
tens31=[[0,0,0];[0,0,0];[0,0,0]];
tens32=[[0,0,0];[0,0,0];[0,(6*BB*KK*kmrgd(2))/(kmrgd(2)^2 + CC)^2 - (8*BB*KK*kmrgd(2)^3)/(kmrgd(2)^2 + CC)^3,0]];
tens33=[[0,0,0];[0,0,0];[0,0,0]];
tens34=[[0,0,0];[0,0,0];[0,(6*BB*KK*kmrgd(2))/(kmrgd(2)^2 + CC)^2 - (8*BB*KK*kmrgd(2)^3)/(kmrgd(2)^2 + CC)^3,0]];
tens35=[[0,0,0];[0,0,0];[(6*BB*KK*kmrgd(2))/(kmrgd(2)^2 + CC)^2 - (8*BB*KK*kmrgd(2)^3)/(kmrgd(2)^2 + CC)^3,(6*KK*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^2 - (48*KK*kmrgd(2)^2*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^3 + (48*KK*kmrgd(2)^4*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^4 + (18*KK*kmrgd(2)*kmrgd(3))/(kmrgd(2)^2 + CC)^2 - (24*KK*kmrgd(2)^3*kmrgd(3))/(kmrgd(2)^2 + CC)^3,(10*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^2 - (2*KK)/(kmrgd(2)^2 + CC) - (8*KK*kmrgd(2)^4)/(kmrgd(2)^2 + CC)^3]];
tens36=[[0,0,0];[0,0,0];[0,(10*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^2 - (2*KK)/(kmrgd(2)^2 + CC) - (8*KK*kmrgd(2)^4)/(kmrgd(2)^2 + CC)^3,0]];
tens37=[[0,0,0];[0,0,0];[0,0,0]];
tens38=[[0,0,0];[0,0,0];[0,(10*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^2 - (2*KK)/(kmrgd(2)^2 + CC) - (8*KK*kmrgd(2)^4)/(kmrgd(2)^2 + CC)^3,0]];
tens39=[[0,0,0];[0,0,0];[0,0,0]];
tens3(:,:,1,1) =tens31;
tens3(:,:,1,2) =tens32;
tens3(:,:,1,3) =tens33;
tens3(:,:,2,1) =tens34;
tens3(:,:,2,2) =tens35;
tens3(:,:,2,3) =tens36;
tens3(:,:,3,1) =tens37;
tens3(:,:,3,2) =tens38;
tens3(:,:,3,3) =tens39;
%---------------------------------------------------------------------------
function tens4  = der4(t,kmrgd,BB,CC,KK)
tens41=[[0,0,0];[0,0,0];[0,0,0]];
tens42=[[0,0,0];[0,0,0];[0,0,0]];
tens43=[[0,0,0];[0,0,0];[0,0,0]];
tens44=[[0,0,0];[0,0,0];[0,0,0]];
tens45=[[0,0,0];[0,0,0];[0,(6*BB*KK)/(kmrgd(2)^2 + CC)^2 - (48*BB*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^3 + (48*BB*KK*kmrgd(2)^4)/(kmrgd(2)^2 + CC)^4,0]];
tens46=[[0,0,0];[0,0,0];[0,0,0]];
tens47=[[0,0,0];[0,0,0];[0,0,0]];
tens48=[[0,0,0];[0,0,0];[0,0,0]];
tens49=[[0,0,0];[0,0,0];[0,0,0]];
tens410=[[0,0,0];[0,0,0];[0,0,0]];
tens411=[[0,0,0];[0,0,0];[0,(6*BB*KK)/(kmrgd(2)^2 + CC)^2 - (48*BB*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^3 + (48*BB*KK*kmrgd(2)^4)/(kmrgd(2)^2 + CC)^4,0]];
tens412=[[0,0,0];[0,0,0];[0,0,0]];
tens413=[[0,0,0];[0,0,0];[0,(6*BB*KK)/(kmrgd(2)^2 + CC)^2 - (48*BB*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^3 + (48*BB*KK*kmrgd(2)^4)/(kmrgd(2)^2 + CC)^4,0]];
tens414=[[0,0,0];[0,0,0];[(6*BB*KK)/(kmrgd(2)^2 + CC)^2 - (48*BB*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^3 + (48*BB*KK*kmrgd(2)^4)/(kmrgd(2)^2 + CC)^4,(24*KK*kmrgd(3))/(kmrgd(2)^2 + CC)^2 - (120*KK*kmrgd(2)*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^3 + (480*KK*kmrgd(2)^3*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^4 - (384*KK*kmrgd(2)^5*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^5 - (192*KK*kmrgd(2)^2*kmrgd(3))/(kmrgd(2)^2 + CC)^3 + (192*KK*kmrgd(2)^4*kmrgd(3))/(kmrgd(2)^2 + CC)^4,(48*KK*kmrgd(2)^5)/(kmrgd(2)^2 + CC)^4 - (72*KK*kmrgd(2)^3)/(kmrgd(2)^2 + CC)^3 + (24*KK*kmrgd(2))/(kmrgd(2)^2 + CC)^2]];
tens415=[[0,0,0];[0,0,0];[0,(48*KK*kmrgd(2)^5)/(kmrgd(2)^2 + CC)^4 - (72*KK*kmrgd(2)^3)/(kmrgd(2)^2 + CC)^3 + (24*KK*kmrgd(2))/(kmrgd(2)^2 + CC)^2,0]];
tens416=[[0,0,0];[0,0,0];[0,0,0]];
tens417=[[0,0,0];[0,0,0];[0,(48*KK*kmrgd(2)^5)/(kmrgd(2)^2 + CC)^4 - (72*KK*kmrgd(2)^3)/(kmrgd(2)^2 + CC)^3 + (24*KK*kmrgd(2))/(kmrgd(2)^2 + CC)^2,0]];
tens418=[[0,0,0];[0,0,0];[0,0,0]];
tens419=[[0,0,0];[0,0,0];[0,0,0]];
tens420=[[0,0,0];[0,0,0];[0,0,0]];
tens421=[[0,0,0];[0,0,0];[0,0,0]];
tens422=[[0,0,0];[0,0,0];[0,0,0]];
tens423=[[0,0,0];[0,0,0];[0,(48*KK*kmrgd(2)^5)/(kmrgd(2)^2 + CC)^4 - (72*KK*kmrgd(2)^3)/(kmrgd(2)^2 + CC)^3 + (24*KK*kmrgd(2))/(kmrgd(2)^2 + CC)^2,0]];
tens424=[[0,0,0];[0,0,0];[0,0,0]];
tens425=[[0,0,0];[0,0,0];[0,0,0]];
tens426=[[0,0,0];[0,0,0];[0,0,0]];
tens427=[[0,0,0];[0,0,0];[0,0,0]];
tens4(:,:,1,1,1) =tens41;
tens4(:,:,1,1,2) =tens42;
tens4(:,:,1,1,3) =tens43;
tens4(:,:,1,2,1) =tens44;
tens4(:,:,1,2,2) =tens45;
tens4(:,:,1,2,3) =tens46;
tens4(:,:,1,3,1) =tens47;
tens4(:,:,1,3,2) =tens48;
tens4(:,:,1,3,3) =tens49;
tens4(:,:,2,1,1) =tens410;
tens4(:,:,2,1,2) =tens411;
tens4(:,:,2,1,3) =tens412;
tens4(:,:,2,2,1) =tens413;
tens4(:,:,2,2,2) =tens414;
tens4(:,:,2,2,3) =tens415;
tens4(:,:,2,3,1) =tens416;
tens4(:,:,2,3,2) =tens417;
tens4(:,:,2,3,3) =tens418;
tens4(:,:,3,1,1) =tens419;
tens4(:,:,3,1,2) =tens420;
tens4(:,:,3,1,3) =tens421;
tens4(:,:,3,2,1) =tens422;
tens4(:,:,3,2,2) =tens423;
tens4(:,:,3,2,3) =tens424;
tens4(:,:,3,3,1) =tens425;
tens4(:,:,3,3,2) =tens426;
tens4(:,:,3,3,3) =tens427;
%---------------------------------------------------------------------------
function tens5  = der5(t,kmrgd,BB,CC,KK)
tens51=[[0,0,0];[0,0,0];[0,0,0]];
tens52=[[0,0,0];[0,0,0];[0,0,0]];
tens53=[[0,0,0];[0,0,0];[0,0,0]];
tens54=[[0,0,0];[0,0,0];[0,0,0]];
tens55=[[0,0,0];[0,0,0];[0,0,0]];
tens56=[[0,0,0];[0,0,0];[0,0,0]];
tens57=[[0,0,0];[0,0,0];[0,0,0]];
tens58=[[0,0,0];[0,0,0];[0,0,0]];
tens59=[[0,0,0];[0,0,0];[0,0,0]];
tens510=[[0,0,0];[0,0,0];[0,0,0]];
tens511=[[0,0,0];[0,0,0];[0,0,0]];
tens512=[[0,0,0];[0,0,0];[0,0,0]];
tens513=[[0,0,0];[0,0,0];[0,0,0]];
tens514=[[0,0,0];[0,0,0];[0,(480*BB*KK*kmrgd(2)^3)/(kmrgd(2)^2 + CC)^4 - (120*BB*KK*kmrgd(2))/(kmrgd(2)^2 + CC)^3 - (384*BB*KK*kmrgd(2)^5)/(kmrgd(2)^2 + CC)^5,0]];
tens515=[[0,0,0];[0,0,0];[0,0,0]];
tens516=[[0,0,0];[0,0,0];[0,0,0]];
tens517=[[0,0,0];[0,0,0];[0,0,0]];
tens518=[[0,0,0];[0,0,0];[0,0,0]];
tens519=[[0,0,0];[0,0,0];[0,0,0]];
tens520=[[0,0,0];[0,0,0];[0,0,0]];
tens521=[[0,0,0];[0,0,0];[0,0,0]];
tens522=[[0,0,0];[0,0,0];[0,0,0]];
tens523=[[0,0,0];[0,0,0];[0,0,0]];
tens524=[[0,0,0];[0,0,0];[0,0,0]];
tens525=[[0,0,0];[0,0,0];[0,0,0]];
tens526=[[0,0,0];[0,0,0];[0,0,0]];
tens527=[[0,0,0];[0,0,0];[0,0,0]];
tens528=[[0,0,0];[0,0,0];[0,0,0]];
tens529=[[0,0,0];[0,0,0];[0,0,0]];
tens530=[[0,0,0];[0,0,0];[0,0,0]];
tens531=[[0,0,0];[0,0,0];[0,0,0]];
tens532=[[0,0,0];[0,0,0];[0,(480*BB*KK*kmrgd(2)^3)/(kmrgd(2)^2 + CC)^4 - (120*BB*KK*kmrgd(2))/(kmrgd(2)^2 + CC)^3 - (384*BB*KK*kmrgd(2)^5)/(kmrgd(2)^2 + CC)^5,0]];
tens533=[[0,0,0];[0,0,0];[0,0,0]];
tens534=[[0,0,0];[0,0,0];[0,0,0]];
tens535=[[0,0,0];[0,0,0];[0,0,0]];
tens536=[[0,0,0];[0,0,0];[0,0,0]];
tens537=[[0,0,0];[0,0,0];[0,0,0]];
tens538=[[0,0,0];[0,0,0];[0,(480*BB*KK*kmrgd(2)^3)/(kmrgd(2)^2 + CC)^4 - (120*BB*KK*kmrgd(2))/(kmrgd(2)^2 + CC)^3 - (384*BB*KK*kmrgd(2)^5)/(kmrgd(2)^2 + CC)^5,0]];
tens539=[[0,0,0];[0,0,0];[0,0,0]];
tens540=[[0,0,0];[0,0,0];[0,(480*BB*KK*kmrgd(2)^3)/(kmrgd(2)^2 + CC)^4 - (120*BB*KK*kmrgd(2))/(kmrgd(2)^2 + CC)^3 - (384*BB*KK*kmrgd(2)^5)/(kmrgd(2)^2 + CC)^5,0]];
tens541=[[0,0,0];[0,0,0];[(480*BB*KK*kmrgd(2)^3)/(kmrgd(2)^2 + CC)^4 - (120*BB*KK*kmrgd(2))/(kmrgd(2)^2 + CC)^3 - (384*BB*KK*kmrgd(2)^5)/(kmrgd(2)^2 + CC)^5,(2160*KK*kmrgd(2)^2*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^4 - (120*KK*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^3 - (5760*KK*kmrgd(2)^4*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^5 + (3840*KK*kmrgd(2)^6*(KK + BB*kmrgd(1) + kmrgd(2)*kmrgd(3) - 1))/(kmrgd(2)^2 + CC)^6 - (600*KK*kmrgd(2)*kmrgd(3))/(kmrgd(2)^2 + CC)^3 + (2400*KK*kmrgd(2)^3*kmrgd(3))/(kmrgd(2)^2 + CC)^4 - (1920*KK*kmrgd(2)^5*kmrgd(3))/(kmrgd(2)^2 + CC)^5,(24*KK)/(kmrgd(2)^2 + CC)^2 - (312*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^3 + (672*KK*kmrgd(2)^4)/(kmrgd(2)^2 + CC)^4 - (384*KK*kmrgd(2)^6)/(kmrgd(2)^2 + CC)^5]];
tens542=[[0,0,0];[0,0,0];[0,(24*KK)/(kmrgd(2)^2 + CC)^2 - (312*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^3 + (672*KK*kmrgd(2)^4)/(kmrgd(2)^2 + CC)^4 - (384*KK*kmrgd(2)^6)/(kmrgd(2)^2 + CC)^5,0]];
tens543=[[0,0,0];[0,0,0];[0,0,0]];
tens544=[[0,0,0];[0,0,0];[0,(24*KK)/(kmrgd(2)^2 + CC)^2 - (312*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^3 + (672*KK*kmrgd(2)^4)/(kmrgd(2)^2 + CC)^4 - (384*KK*kmrgd(2)^6)/(kmrgd(2)^2 + CC)^5,0]];
tens545=[[0,0,0];[0,0,0];[0,0,0]];
tens546=[[0,0,0];[0,0,0];[0,0,0]];
tens547=[[0,0,0];[0,0,0];[0,0,0]];
tens548=[[0,0,0];[0,0,0];[0,0,0]];
tens549=[[0,0,0];[0,0,0];[0,0,0]];
tens550=[[0,0,0];[0,0,0];[0,(24*KK)/(kmrgd(2)^2 + CC)^2 - (312*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^3 + (672*KK*kmrgd(2)^4)/(kmrgd(2)^2 + CC)^4 - (384*KK*kmrgd(2)^6)/(kmrgd(2)^2 + CC)^5,0]];
tens551=[[0,0,0];[0,0,0];[0,0,0]];
tens552=[[0,0,0];[0,0,0];[0,0,0]];
tens553=[[0,0,0];[0,0,0];[0,0,0]];
tens554=[[0,0,0];[0,0,0];[0,0,0]];
tens555=[[0,0,0];[0,0,0];[0,0,0]];
tens556=[[0,0,0];[0,0,0];[0,0,0]];
tens557=[[0,0,0];[0,0,0];[0,0,0]];
tens558=[[0,0,0];[0,0,0];[0,0,0]];
tens559=[[0,0,0];[0,0,0];[0,0,0]];
tens560=[[0,0,0];[0,0,0];[0,0,0]];
tens561=[[0,0,0];[0,0,0];[0,0,0]];
tens562=[[0,0,0];[0,0,0];[0,0,0]];
tens563=[[0,0,0];[0,0,0];[0,0,0]];
tens564=[[0,0,0];[0,0,0];[0,0,0]];
tens565=[[0,0,0];[0,0,0];[0,0,0]];
tens566=[[0,0,0];[0,0,0];[0,0,0]];
tens567=[[0,0,0];[0,0,0];[0,0,0]];
tens568=[[0,0,0];[0,0,0];[0,(24*KK)/(kmrgd(2)^2 + CC)^2 - (312*KK*kmrgd(2)^2)/(kmrgd(2)^2 + CC)^3 + (672*KK*kmrgd(2)^4)/(kmrgd(2)^2 + CC)^4 - (384*KK*kmrgd(2)^6)/(kmrgd(2)^2 + CC)^5,0]];
tens569=[[0,0,0];[0,0,0];[0,0,0]];
tens570=[[0,0,0];[0,0,0];[0,0,0]];
tens571=[[0,0,0];[0,0,0];[0,0,0]];
tens572=[[0,0,0];[0,0,0];[0,0,0]];
tens573=[[0,0,0];[0,0,0];[0,0,0]];
tens574=[[0,0,0];[0,0,0];[0,0,0]];
tens575=[[0,0,0];[0,0,0];[0,0,0]];
tens576=[[0,0,0];[0,0,0];[0,0,0]];
tens577=[[0,0,0];[0,0,0];[0,0,0]];
tens578=[[0,0,0];[0,0,0];[0,0,0]];
tens579=[[0,0,0];[0,0,0];[0,0,0]];
tens580=[[0,0,0];[0,0,0];[0,0,0]];
tens581=[[0,0,0];[0,0,0];[0,0,0]];
tens5(:,:,1,1,1,1) =tens51;
tens5(:,:,1,1,1,2) =tens52;
tens5(:,:,1,1,1,3) =tens53;
tens5(:,:,1,1,2,1) =tens54;
tens5(:,:,1,1,2,2) =tens55;
tens5(:,:,1,1,2,3) =tens56;
tens5(:,:,1,1,3,1) =tens57;
tens5(:,:,1,1,3,2) =tens58;
tens5(:,:,1,1,3,3) =tens59;
tens5(:,:,1,2,1,1) =tens510;
tens5(:,:,1,2,1,2) =tens511;
tens5(:,:,1,2,1,3) =tens512;
tens5(:,:,1,2,2,1) =tens513;
tens5(:,:,1,2,2,2) =tens514;
tens5(:,:,1,2,2,3) =tens515;
tens5(:,:,1,2,3,1) =tens516;
tens5(:,:,1,2,3,2) =tens517;
tens5(:,:,1,2,3,3) =tens518;
tens5(:,:,1,3,1,1) =tens519;
tens5(:,:,1,3,1,2) =tens520;
tens5(:,:,1,3,1,3) =tens521;
tens5(:,:,1,3,2,1) =tens522;
tens5(:,:,1,3,2,2) =tens523;
tens5(:,:,1,3,2,3) =tens524;
tens5(:,:,1,3,3,1) =tens525;
tens5(:,:,1,3,3,2) =tens526;
tens5(:,:,1,3,3,3) =tens527;
tens5(:,:,2,1,1,1) =tens528;
tens5(:,:,2,1,1,2) =tens529;
tens5(:,:,2,1,1,3) =tens530;
tens5(:,:,2,1,2,1) =tens531;
tens5(:,:,2,1,2,2) =tens532;
tens5(:,:,2,1,2,3) =tens533;
tens5(:,:,2,1,3,1) =tens534;
tens5(:,:,2,1,3,2) =tens535;
tens5(:,:,2,1,3,3) =tens536;
tens5(:,:,2,2,1,1) =tens537;
tens5(:,:,2,2,1,2) =tens538;
tens5(:,:,2,2,1,3) =tens539;
tens5(:,:,2,2,2,1) =tens540;
tens5(:,:,2,2,2,2) =tens541;
tens5(:,:,2,2,2,3) =tens542;
tens5(:,:,2,2,3,1) =tens543;
tens5(:,:,2,2,3,2) =tens544;
tens5(:,:,2,2,3,3) =tens545;
tens5(:,:,2,3,1,1) =tens546;
tens5(:,:,2,3,1,2) =tens547;
tens5(:,:,2,3,1,3) =tens548;
tens5(:,:,2,3,2,1) =tens549;
tens5(:,:,2,3,2,2) =tens550;
tens5(:,:,2,3,2,3) =tens551;
tens5(:,:,2,3,3,1) =tens552;
tens5(:,:,2,3,3,2) =tens553;
tens5(:,:,2,3,3,3) =tens554;
tens5(:,:,3,1,1,1) =tens555;
tens5(:,:,3,1,1,2) =tens556;
tens5(:,:,3,1,1,3) =tens557;
tens5(:,:,3,1,2,1) =tens558;
tens5(:,:,3,1,2,2) =tens559;
tens5(:,:,3,1,2,3) =tens560;
tens5(:,:,3,1,3,1) =tens561;
tens5(:,:,3,1,3,2) =tens562;
tens5(:,:,3,1,3,3) =tens563;
tens5(:,:,3,2,1,1) =tens564;
tens5(:,:,3,2,1,2) =tens565;
tens5(:,:,3,2,1,3) =tens566;
tens5(:,:,3,2,2,1) =tens567;
tens5(:,:,3,2,2,2) =tens568;
tens5(:,:,3,2,2,3) =tens569;
tens5(:,:,3,2,3,1) =tens570;
tens5(:,:,3,2,3,2) =tens571;
tens5(:,:,3,2,3,3) =tens572;
tens5(:,:,3,3,1,1) =tens573;
tens5(:,:,3,3,1,2) =tens574;
tens5(:,:,3,3,1,3) =tens575;
tens5(:,:,3,3,2,1) =tens576;
tens5(:,:,3,3,2,2) =tens577;
tens5(:,:,3,3,2,3) =tens578;
tens5(:,:,3,3,3,1) =tens579;
tens5(:,:,3,3,3,2) =tens580;
tens5(:,:,3,3,3,3) =tens581;
