function out = Duopoly
out{1} = @init;
out{2} = @fun_eval;
out{3} = @jacobian;
out{4} = @jacobianp;
out{5} = @hessians;
out{6} = @hessiansp;
out{7} = @der3;
out{8} = [];
out{9} = [];

% --------------------------------------------------------------------------
function dydt = fun_eval(t,kmrgd,a,b)
dydt=[sqrt(kmrgd(2)/a)-kmrgd(2);
sqrt(kmrgd(1)/b)-kmrgd(1);];

% --------------------------------------------------------------------------
function [tspan,y0,options] = init
handles = feval(Duopoly);
y0=[0,0];
options = odeset('Jacobian',handles(3),'JacobianP',handles(4),'Hessians',handles(5),'HessiansP',handles(6));
tspan = [0 10];

% --------------------------------------------------------------------------
function jac = jacobian(t,kmrgd,a,b)
jac=[ 0 , 1/(2*a*(kmrgd(2)/a)^(1/2)) - 1 ; 1/(2*b*(kmrgd(1)/b)^(1/2)) - 1 , 0 ];
% --------------------------------------------------------------------------
function jacp = jacobianp(t,kmrgd,a,b)
jacp=[ -kmrgd(2)/(2*a^2*(kmrgd(2)/a)^(1/2)) , 0 ; 0 , -kmrgd(1)/(2*b^2*(kmrgd(1)/b)^(1/2)) ];
% --------------------------------------------------------------------------
function hess = hessians(t,kmrgd,a,b)
hess1=[ 0 , 0 ; -1/(4*b^2*(kmrgd(1)/b)^(3/2)) , 0 ];
hess2=[ 0 , -1/(4*a^2*(kmrgd(2)/a)^(3/2)) ; 0 , 0 ];
hess(:,:,1) =hess1;
hess(:,:,2) =hess2;
% --------------------------------------------------------------------------
function hessp = hessiansp(t,kmrgd,a,b)
hessp1=[ 0 , kmrgd(2)/(4*a^3*(kmrgd(2)/a)^(3/2)) - 1/(2*a^2*(kmrgd(2)/a)^(1/2)) ; 0 , 0 ];
hessp2=[ 0 , 0 ; kmrgd(1)/(4*b^3*(kmrgd(1)/b)^(3/2)) - 1/(2*b^2*(kmrgd(1)/b)^(1/2)) , 0 ];
hessp(:,:,1) =hessp1;
hessp(:,:,2) =hessp2;
%---------------------------------------------------------------------------
function tens3  = der3(t,kmrgd,a,b)
tens31=[ 0 , 0 ; 3/(8*b^3*(kmrgd(1)/b)^(5/2)) , 0 ];
tens32=[ 0 , 0 ; 0 , 0 ];
tens33=[ 0 , 0 ; 0 , 0 ];
tens34=[ 0 , 3/(8*a^3*(kmrgd(2)/a)^(5/2)) ; 0 , 0 ];
tens3(:,:,1,1) =tens31;
tens3(:,:,1,2) =tens32;
tens3(:,:,2,1) =tens33;
tens3(:,:,2,2) =tens34;
%---------------------------------------------------------------------------
function tens4  = der4(t,kmrgd,a,b)
%---------------------------------------------------------------------------
function tens5  = der5(t,kmrgd,a,b)
